#include <ocl/TaskBrowser.hpp>
#include <rtt/os/main.h>
 // ...

#include <ocl/DeploymentComponent.hpp>
#include <rtt/PeriodicActivity.hpp>

#include <iostream>

using namespace Orocos;
using namespace std;

class Hello: public TaskContext {
public:

	ProgramInterfacePtr m_prgFoo;

	Method<void(string)> mthPrintLog;

	void mthDoPrintLog(string s) {
		log(Warning) << s << endlog();
	}

	Hello(std::string name)
            : TaskContext(name),	
	      mthPrintLog("mthPrintLog", &Hello::mthDoPrintLog, this) {

		this->methods()->addMethod(&mthPrintLog, "prints a Log","text", "text to log");

//            this->start();
	}

	bool configureHook() {
		cout << "configureHook()...." << endl;
		//chargement du programme qui charge les fonctions externes
		ScriptingAccess* sa = this->scripting();

		sa->loadPrograms("foo.ops");

		m_prgFoo = this->engine()->programs()->getProgram("PrgFoo");

		if (m_prgFoo == NULL) {
			cout << "Failed to find program" << endl;
			return false;
		}

		cout << "configureHook() done." << endl;
		return true;
	}

	bool startHook() {
		cout << "startHook()...." << endl;
		cout << "Executing prgFoo..." << endl;

		m_prgFoo->start();
		cout << "startHook done." << endl;
		return true;
	}	

	void updateHook() {
	      cout << "updateHook()...." << endl;
	      cout << "updateHook done." << endl;
	}
};

int ORO_main( int argc, char** argv)
  {

      cout << "Started...." << endl;

      // Create your tasks
      Hello hello("hello");

      hello.configure();

      PeriodicActivity act(ORO_SCHED_OTHER, 1, 5, hello.engine() );

      hello.start();

      for (;;) {
	cout << "Alive" << endl;
	sleep(1);		
      }

      return 0;
  }

      
